<?php
/**
* @version		0.9.1
* @package		DJ Classifieds
* @subpackage	DJ Classifieds Menu Module
* @copyright	Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.
* @license		http://www.gnu.org/licenses GNU/GPL
* @autor url    http://design-joomla.eu
* @autor email  contact@design-joomla.eu
* @Developer    Lukasz Ciastek - lukasz.ciastek@design-joomla.eu
* 
* 
* DJ Classifieds is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Classifieds is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Classifieds. If not, see <http://www.gnu.org/licenses/>.
* 
*/

function renderMenu(&$root, $catid, $Itemid, $layout = 1, $expand) {
		
	$levels = array();
	makeDjCatTree(0, $levels, $root);
	if ($layout == 1)
		$lay = 'blog';
	else $lay ='default';
	if (count($levels))
		renderList($levels, 0, $catid, $Itemid, $lay, $expand, 0, $root);
}

function renderList(&$list, $current, $catid, $Itemid, $lay, $expand, $level=0,&$root) {
	
	foreach ($list[$current] as $key=>$value) {
		$active = false;
		$activeChildren = 0;
		$class='class="';
		$id='';
		checkIfActive($list, $key, $catid, $activeChildren);
		if ($key == $catid || $activeChildren) {
			$active = true;
			$class.='active';
			if ($key == $catid)
				$id='id="current"';
		}
		if (count($list[$key]))
			$class.=' parent';
		$class.=' level'.$level.'"';
		echo('<li '.$class.' '.$id.'>');
		
		if(checkChilds($root, $key)){
			echo JHTML::link(JRoute::_('index.php?option=com_djclassifieds&view=show&cid='.$key.'&Itemid='.$Itemid), '<span>'.$value.'</span>');
		}else{
			echo JHTML::link(JRoute::_('index.php?option=com_djclassifieds&view=showlist&cid='.$key.'&Itemid='.$Itemid), '<span>'.$value.'</span>');
		}
		if (count($list[$key]) && ($active || $expand)) {
			echo('<ul>');
			renderList($list, $key, $catid, $Itemid, $lay, $expand, $level+1,&$root);
			echo('</ul>');
		}
		echo('</li>');
	}
}

function checkIfActive (&$list, $current, $catid, &$check) {

	if (count($list[$current])) {
		foreach ($list[$current] as $key=>$value) {
			if ($key == $catid) {
				$check++;
			}
			elseif (count($list[$key]))
				checkIfActive($list, $key, $catid,$check);
		}
	}
}

function makeDjCatTree($parentid, &$tab, $table) {
	
	foreach($table as $value) {
		if ($value->parent_id == $parentid) {
			$catid = $value->id;
			$tab[$parentid][$catid]= $value->name;
			makeDjCatTree($value->id, $tab, $table);
		}
	}	
}



class DjclassifiedsModelCategories{
	
	var $_categories;
	
	function getCategories(){
		$db= &JFactory::getDBO();
			$query = "SELECT * FROM #__djcf_categories WHERE published = 1";
			$db->setQuery($query);
			$_categories=$db->loadObjectList();
		

		return $_categories;
	}
}

function checkChilds($list, $id){
	foreach($list as $li){
		if($li->parent_id==$id){
			return true;
		}
	}
	return false;
}
?>
